package com.qmth.teachcloud.report.business.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.teachcloud.common.contant.SystemConstant;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Objects;

/**
 * @Description: 参考课程班级下授课教师维度分析表
 * @Author: CaoZixuan
 * @Date: 2022-06-24
 */
@ApiModel(value = "TAExamCourseClazzTeacher对象", description = "参考课程班级下授课教师维度分析表")
public class TAExamCourseClazzTeacher implements Serializable {
    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "id")
    @JsonSerialize(using = ToStringSerializer.class)
    @TableId(value = "id")
    private Long id;

    @ApiModelProperty(value = "考试id")
    @JsonSerialize(using = ToStringSerializer.class)
    @TableField(value = "exam_id")
    private Long examId;

    @ApiModelProperty(value = "学校id")
    @JsonSerialize(using = ToStringSerializer.class)
    @TableField(value = "school_id")
    private Long schoolId;

    @ApiModelProperty(value = "科目编码")
    @TableField(value = "course_code")
    private String courseCode;

    @ApiModelProperty(value = "科目名称")
    @TableField(value = "course_name")
    private String courseName;

    @ApiModelProperty(value = "授课班级id（此表以该字段为统计）")
    @JsonSerialize(using = ToStringSerializer.class)
    @TableField(value = "clazz_id")
    private Long clazzId;

    @ApiModelProperty(value = "授课班级编号（冗余）")
    @TableField(value = "clazz_code")
    private String clazzCode;

    @ApiModelProperty(value = "授课教师id")
    @JsonSerialize(using = ToStringSerializer.class)
    @TableField(value = "teacher_id")
    private Long teacherId;

    @ApiModelProperty(value = "主体考察学院id（班级所在最多数学生所在学院）")
    @JsonSerialize(using = ToStringSerializer.class)
    @TableField(value = "main_college_ids")
    private String mainCollegeIds;

    @ApiModelProperty(value = "主体考察学院名称（冗余）")
    @TableField(value = "main_college_names")
    private String mainCollegeNames;

    @ApiModelProperty(value = "授课教师名称（冗余）")
    @TableField(value = "teacher_name")
    private String teacherName;

    @ApiModelProperty(value = "客观题卷面平均分")
    @TableField(value = "obj_avg_score")
    private BigDecimal objAvgScore;

    @ApiModelProperty(value = "主观题卷面平均分")
    @TableField(value = "sub_avg_score")
    private BigDecimal subAvgScore;

    @ApiModelProperty(value = "卷面平均分")
    @TableField(value = "avg_score")
    private BigDecimal avgScore;

    @ApiModelProperty(value = "赋分后授课学生最低分")
    @TableField(value = "min_score_assign")
    private BigDecimal minScoreAssign;

    @ApiModelProperty(value = "赋分后授课学生最高分")
    @TableField(value = "max_score_assign")
    private BigDecimal maxScoreAssign;

    @ApiModelProperty(value = "赋分后授课学生平均分")
    @TableField(value = "avg_score_assign")
    private BigDecimal avgScoreAssign;

    @ApiModelProperty(value = "授课学生分数上四分位数")
    @TableField(value = "upper_quartile")
    private BigDecimal upperQuartile;

    @ApiModelProperty(value = "授课学生中位数")
    @TableField(value = "median")
    private BigDecimal median;

    @ApiModelProperty(value = "授课学生分数下四分位数")
    @TableField(value = "lower_quartile")
    private BigDecimal lowerQuartile;

    @ApiModelProperty(value = "授课学生分数众数")
    @TableField(value = "mode")
    private String mode;

    @ApiModelProperty(value = "授课学生分数标准差")
    @TableField(value = "standard_deviation")
    private BigDecimal standardDeviation;

    @ApiModelProperty(value = "授课学生分数相对位置")
    @TableField(value = "relative_position")
    private BigDecimal relativePosition;

    @ApiModelProperty(value = "授课学生实际参考人数")
    @TableField(value = "reality_count")
    private Integer realityCount;

    @ApiModelProperty(value = "授课学生缺考人数")
    @TableField(value = "absent_count")
    private Integer absentCount;

    @ApiModelProperty(value = "总人数")
    @TableField(value = "total_count")
    private Integer totalCount;

    @ApiModelProperty(value = "授课学院id")
    @JsonSerialize(using = ToStringSerializer.class)
    @TableField(value = "teach_college_id")
    private Long teachCollegeId;

    @ApiModelProperty(value = "授课学院名称")
    @TableField(value = "teach_college_name")
    private String teachCollegeName;

    @ApiModelProperty(value = "该科目，授课班级下排名")
    @TableField(value = "teacher_rank")
    private Integer teacherRank;

    @ApiModelProperty(value = "教师人数")
    @TableField(value = "teacher_count")
    private Integer teacherCount;

    @ApiModelProperty(value = "其他班级授课学生最低分（赋分）")
    @TableField(value = "other_clazz_min_score_assign")
    private BigDecimal otherClazzMinScoreAssign;

    @ApiModelProperty(value = "其他班级授课学生最高分（赋分）")
    @TableField(value = "other_clazz_max_score_assign")
    private BigDecimal otherClazzMaxScoreAssign;

    @ApiModelProperty(value = "其他班级授课学生平均分（赋分）")
    @TableField(value = "other_clazz_avg_score_assign")
    private BigDecimal otherClazzAvgScoreAssign;

    @ApiModelProperty(value = "其他班级授课学生分数上四分位数")
    @TableField(value = "other_clazz_upper_quartile")
    private BigDecimal otherClazzUpperQuartile;

    @ApiModelProperty(value = "其他班级授课学生中位数")
    @TableField(value = "other_clazz_median")
    private BigDecimal otherClazzMedian;

    @ApiModelProperty(value = "其他班级授课学生分数下四分位数")
    @TableField(value = "other_clazz_lower_quartile")
    private BigDecimal otherClazzLowerQuartile;

    @ApiModelProperty(value = "其他班级授课学生分数众数")
    @TableField(value = "other_clazz_mode")
    private String otherClazzMode;

    @ApiModelProperty(value = "其他班级授课学生实际参考人数")
    @TableField(value = "other_clazz_reality_count")
    private Integer otherClazzRealityCount;

    @ApiModelProperty(value = "其他班级授课学生缺考人数")
    @TableField(value = "other_clazz_absent_count")
    private Integer otherClazzAbsentCount;

    @ApiModelProperty(value = "其他班级总人数")
    @TableField(value = "other_clazz_total_count")
    private Integer otherClazzTotalCount;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }

    public Long getSchoolId() {
        return schoolId;
    }

    public void setSchoolId(Long schoolId) {
        this.schoolId = schoolId;
    }

    public String getCourseCode() {
        return courseCode;
    }

    public void setCourseCode(String courseCode) {
        this.courseCode = courseCode;
    }

    public String getCourseName() {
        return courseName;
    }

    public void setCourseName(String courseName) {
        this.courseName = courseName;
    }

    public Long getClazzId() {
        return clazzId;
    }

    public void setClazzId(Long clazzId) {
        this.clazzId = clazzId;
    }

    public String getClazzCode() {
        return clazzCode;
    }

    public void setClazzCode(String clazzCode) {
        this.clazzCode = clazzCode;
    }

    public Long getTeacherId() {
        return teacherId;
    }

    public void setTeacherId(Long teacherId) {
        this.teacherId = teacherId;
    }

    public String getMainCollegeIds() {
        return mainCollegeIds;
    }

    public void setMainCollegeIds(String mainCollegeIds) {
        this.mainCollegeIds = mainCollegeIds;
    }

    public String getMainCollegeNames() {
        return mainCollegeNames;
    }

    public void setMainCollegeNames(String mainCollegeNames) {
        this.mainCollegeNames = mainCollegeNames;
    }

    public String getTeacherName() {
        return teacherName;
    }

    public void setTeacherName(String teacherName) {
        this.teacherName = teacherName;
    }

    public BigDecimal getObjAvgScore() {
        if (Objects.nonNull(objAvgScore)) {
            return objAvgScore.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setObjAvgScore(BigDecimal objAvgScore) {
        this.objAvgScore = objAvgScore;
    }

    public BigDecimal getSubAvgScore() {
        if (Objects.nonNull(subAvgScore)) {
            return subAvgScore.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setSubAvgScore(BigDecimal subAvgScore) {
        this.subAvgScore = subAvgScore;
    }

    public BigDecimal getAvgScore() {
        if (Objects.nonNull(avgScore)) {
            return avgScore.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setAvgScore(BigDecimal avgScore) {
        this.avgScore = avgScore;
    }

    public BigDecimal getMinScoreAssign() {
        if (Objects.nonNull(minScoreAssign)) {
            return minScoreAssign.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setMinScoreAssign(BigDecimal minScoreAssign) {
        this.minScoreAssign = minScoreAssign;
    }

    public BigDecimal getMaxScoreAssign() {
        if (Objects.nonNull(maxScoreAssign)) {
            return maxScoreAssign.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setMaxScoreAssign(BigDecimal maxScoreAssign) {
        this.maxScoreAssign = maxScoreAssign;
    }

    public BigDecimal getAvgScoreAssign() {
        if (Objects.nonNull(avgScoreAssign)) {
            return avgScoreAssign.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setAvgScoreAssign(BigDecimal avgScoreAssign) {
        this.avgScoreAssign = avgScoreAssign;
    }

    public BigDecimal getUpperQuartile() {
        if (Objects.nonNull(upperQuartile)) {
            return upperQuartile.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setUpperQuartile(BigDecimal upperQuartile) {
        this.upperQuartile = upperQuartile;
    }

    public BigDecimal getMedian() {
        if (Objects.nonNull(median)) {
            return median.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setMedian(BigDecimal median) {
        this.median = median;
    }

    public BigDecimal getLowerQuartile() {
        if (Objects.nonNull(lowerQuartile)) {
            return lowerQuartile.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setLowerQuartile(BigDecimal lowerQuartile) {
        this.lowerQuartile = lowerQuartile;
    }

    public String getMode() {
        return mode;
    }

    public void setMode(String mode) {
        this.mode = mode;
    }

    public BigDecimal getStandardDeviation() {
        if (Objects.nonNull(standardDeviation)) {
            return standardDeviation.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setStandardDeviation(BigDecimal standardDeviation) {
        this.standardDeviation = standardDeviation;
    }

    public BigDecimal getRelativePosition() {
        if (Objects.nonNull(relativePosition)) {
            return relativePosition.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setRelativePosition(BigDecimal relativePosition) {
        this.relativePosition = relativePosition;
    }

    public Integer getRealityCount() {
        return realityCount;
    }

    public void setRealityCount(Integer realityCount) {
        this.realityCount = realityCount;
    }

    public Integer getAbsentCount() {
        return absentCount;
    }

    public void setAbsentCount(Integer absentCount) {
        this.absentCount = absentCount;
    }

    public Integer getTotalCount() {
        return totalCount;
    }

    public void setTotalCount(Integer totalCount) {
        this.totalCount = totalCount;
    }

    public Long getTeachCollegeId() {
        return teachCollegeId;
    }

    public void setTeachCollegeId(Long teachCollegeId) {
        this.teachCollegeId = teachCollegeId;
    }

    public String getTeachCollegeName() {
        return teachCollegeName;
    }

    public void setTeachCollegeName(String teachCollegeName) {
        this.teachCollegeName = teachCollegeName;
    }

    public Integer getTeacherRank() {
        return teacherRank;
    }

    public void setTeacherRank(Integer teacherRank) {
        this.teacherRank = teacherRank;
    }

    public Integer getTeacherCount() {
        return teacherCount;
    }

    public void setTeacherCount(Integer teacherCount) {
        this.teacherCount = teacherCount;
    }

    public BigDecimal getOtherClazzMinScoreAssign() {
        if (Objects.nonNull(otherClazzMinScoreAssign)) {
            return otherClazzMinScoreAssign.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setOtherClazzMinScoreAssign(BigDecimal otherClazzMinScoreAssign) {
        this.otherClazzMinScoreAssign = otherClazzMinScoreAssign;
    }

    public BigDecimal getOtherClazzMaxScoreAssign() {
        if (Objects.nonNull(otherClazzMaxScoreAssign)) {
            return otherClazzMaxScoreAssign.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setOtherClazzMaxScoreAssign(BigDecimal otherClazzMaxScoreAssign) {
        this.otherClazzMaxScoreAssign = otherClazzMaxScoreAssign;
    }

    public BigDecimal getOtherClazzAvgScoreAssign() {
        if (Objects.nonNull(otherClazzAvgScoreAssign)) {
            return otherClazzAvgScoreAssign.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setOtherClazzAvgScoreAssign(BigDecimal otherClazzAvgScoreAssign) {
        this.otherClazzAvgScoreAssign = otherClazzAvgScoreAssign;
    }

    public BigDecimal getOtherClazzUpperQuartile() {
        if (Objects.nonNull(otherClazzUpperQuartile)) {
            return otherClazzUpperQuartile.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setOtherClazzUpperQuartile(BigDecimal otherClazzUpperQuartile) {
        this.otherClazzUpperQuartile = otherClazzUpperQuartile;
    }

    public BigDecimal getOtherClazzMedian() {
        if (Objects.nonNull(otherClazzMedian)) {
            return otherClazzMedian.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setOtherClazzMedian(BigDecimal otherClazzMedian) {
        this.otherClazzMedian = otherClazzMedian;
    }

    public BigDecimal getOtherClazzLowerQuartile() {
        if (Objects.nonNull(otherClazzLowerQuartile)) {
            return otherClazzLowerQuartile.setScale(SystemConstant.CALCULATE_SCALE, RoundingMode.HALF_UP);
        } else {
            return null;
        }
    }

    public void setOtherClazzLowerQuartile(BigDecimal otherClazzLowerQuartile) {
        this.otherClazzLowerQuartile = otherClazzLowerQuartile;
    }

    public String getOtherClazzMode() {
        return otherClazzMode;
    }

    public void setOtherClazzMode(String otherClazzMode) {
        this.otherClazzMode = otherClazzMode;
    }

    public Integer getOtherClazzRealityCount() {
        return otherClazzRealityCount;
    }

    public void setOtherClazzRealityCount(Integer otherClazzRealityCount) {
        this.otherClazzRealityCount = otherClazzRealityCount;
    }

    public Integer getOtherClazzAbsentCount() {
        return otherClazzAbsentCount;
    }

    public void setOtherClazzAbsentCount(Integer otherClazzAbsentCount) {
        this.otherClazzAbsentCount = otherClazzAbsentCount;
    }

    public Integer getOtherClazzTotalCount() {
        return otherClazzTotalCount;
    }

    public void setOtherClazzTotalCount(Integer otherClazzTotalCount) {
        this.otherClazzTotalCount = otherClazzTotalCount;
    }
}
