package com.qmth.teachcloud.report.business.service;

import java.util.concurrent.CompletableFuture;

/**
 * @Description: 数据分析计算线程服务类
 * @Author: CaoZixuan
 * @Date: 2022-05-11
 */
public interface DataAnalyzeService {

    /**
     * 前置表计算任务
     *
     * @param examId     考试id
     * @param courseCode 分析课程编号
     */
    void predecessorAnalyzeTask(Long examId, String courseCode) throws Exception;

    /**
     * 其他表多线程计算任务
     *
     * @param examId     考试id
     * @param courseCode 分析课程编号
     */
    void asyncAnalyzeTask(Long examId, String courseCode) throws Exception;

    /**
     * 数据计算
     *
     * @param examId     考试id
     * @param courseCode 分析课程编号
     */
    CompletableFuture<Boolean> dataCalculate(Long examId, String courseCode) throws Exception;

}
