package com.qmth.teachcloud.report.report;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.qmth.teachcloud.report.TeachcloudReportApplication;
import com.qmth.teachcloud.report.business.bean.dto.gradeAnalyze.ModuleDefine;
import com.qmth.teachcloud.report.business.bean.dto.gradeAnalyze.ModuleEvaluation;
import com.qmth.teachcloud.report.business.bean.dto.gradeAnalyze.SecondaryDimensionLevelDefine;
import com.qmth.teachcloud.report.business.entity.TBDimension;
import com.qmth.teachcloud.report.business.entity.TBModuleProficiency;
import com.qmth.teachcloud.report.business.entity.TBPaper;
import com.qmth.teachcloud.report.business.entity.TBPaperStruct;
import com.qmth.teachcloud.report.business.service.*;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * @Description:
 * @Author: CaoZixuan
 * @Date:
 */
@SpringBootTest(classes = {TeachcloudReportApplication.class})
@RunWith(SpringRunner.class)
public class CourseReportTest {
    @Resource
    private CourseReportService courseReportService;
    @Resource
    private TAExamCourseService taExamCourseService;
    @Resource
    private ChangNamesService changNamesService;
    @Resource
    private TBDimensionService tbDimensionService;
    @Resource
    private TBPaperStructService tbPaperStructService;
    @Resource
    private TBPaperService tbPaperService;

    @Test
    public void inspectTotal(){

    }

    @Test
    public void trail(){
        long examId = 1L;
        String examCode = "1013";
        String coefficient = "4.5";
        System.out.println(JSON.toJSONString(taExamCourseService.trialCalculate(examId,examCode,coefficient)));
    }

    @Test
    public void findDimension(){
        String courseCode= "2016";
        System.out.println(JSON.toJSONString(tbDimensionService.list(new QueryWrapper<TBDimension>().lambda().eq(TBDimension::getCourseCode,courseCode)).get(0)));
    }

    @Test
    public void findPaperStructure(){
        String courseCode = "2016";
        Long paperId = 208613958230216704L;
        System.out.println(JSON.toJSONString(tbPaperStructService.list(new QueryWrapper<TBPaperStruct>().lambda().eq(TBPaperStruct::getPaperId,paperId)).get(0)));
    }

    @Test
    public void findBasicPaper(){
        String courseCode = "2016";
        System.out.println(JSON.toJSONString(tbPaperService.list(new QueryWrapper<TBPaper>().lambda().eq(TBPaper::getCourseCode,courseCode))));
    }

    @Test
    public void findModuleDefine(){
        List<ModuleDefine> moduleDefineList = new ArrayList<>();
        ModuleDefine moduleDefine = new ModuleDefine();
        moduleDefine.setModuleType("知识");
        moduleDefine.setInterpret("课程标准规定的学科内容");
        moduleDefine.setRemark("与以往传统考试单纯以部分对学生进行排序的评价方式不同，四维诊断评价能够综合分析你的学业发展长短板、优劣势，经由系统分析后出具详细的学业诊断评价报告。");

        // -- 二级维度精熟度定义
        List<SecondaryDimensionLevelDefine> secondaryDimensionLevelDefineList = new ArrayList<>();
        SecondaryDimensionLevelDefine s1 = new SecondaryDimensionLevelDefine();
        s1.setDefine("熟练掌握：个人得分率≥90%");
        s1.setLevel("A");
        s1.setMin("0.9");
        s1.setMax("1");
        s1.setScope("[0.9,1]");
        secondaryDimensionLevelDefineList.add(s1);
        moduleDefine.setSecondaryDimensionLevelDefineList(secondaryDimensionLevelDefineList);

        // -- 评价
        moduleDefine.setFormula("得分率");
        List<ModuleEvaluation> moduleEvaluationList = new ArrayList<>();
        ModuleEvaluation m1 = new ModuleEvaluation();
        m1.setLevelCode("A");
        m1.setLevelName("表现优秀水平");
        m1.setScope("[0.9,1]");
        m1.setResult("作答结果反映你在本次测试中表现优秀。你对本学期的知识点掌握的非常牢固，能够将所学的物理概念、规律和结论灵活用于解决相关的物理问题；具有将所学的物理知识，结合一定的数学手段解复杂的或综合性物理问题的能力。");
        m1.setAdvice("希望你在后续课程的的学习中能够继续保持这种学习的态度和热情，戒骄戒躁，不忘初心，进一步拓宽知识面，进行个性化的深入学习，相信你一定会取得更优秀的成绩。");
        moduleEvaluationList.add(m1);
        moduleDefine.setModuleEvaluationList(moduleEvaluationList);
        moduleDefineList.add(moduleDefine);
        System.out.println(JSON.toJSONString(moduleDefineList));
    }

}
